/* crash.h - part of crash
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _crash_h_
#define _crash_h_

/****************************************************************
*	}N							*
****************************************************************/

#define MAX_PARGS 32				/* R}hC̍ő */

#define VERBOSE(l,x) \
    if (flagVerbose >= (l)) x			/* bZ[W\}N */

/****************************************************************
*	OϐQ						*
****************************************************************/

extern int binIndex;				/* jAe[ǔTCY */
extern int binAlloc;				/* jAe[ů蓖ăTCY */
extern int flagVerbose;				/* verbose \x */
extern int imageSize;				/* RAC[WTCY */
extern char *coreFname;				/* RAC[Wt@C */
extern char *execFname;				/* st@C */
extern struct aouthdr aout;			/* st@Cwb_ */
extern struct corehdr core;			/* RAwb_ */
extern struct sym **binTable;			/* jAe[uւ̃|C^ */
extern struct sym *hashTable[];			/* nbVe[u */
extern unsigned char *image;			/* RAC[W */

/****************************************************************
*	vg^Cv						*
****************************************************************/

char *ConvertDeviceMode (int mode);
char *ConvertOpenMode (int mode);
char *ConvertStreamMode (int mode);
char *SearchByAddress (int address);
int PromptInput (const char *, int *, char ***);
struct cnode *SearchCommand (char *str, int len);
void *SearchByName (const char *name);
void Error (const char *format, ...);
void ReadCore (const char *fname);
void ReadSymbols (const char *fname);
void ShowFileHandle (int argc, char **argv);
void ShowHelp (int argc, char **argv);
void ShowPosition (int argc, char **argv);
void ShowProcess (int argc, char **argv);
void ShowQuit (int argc, char **argv);
void ShowStack (int argc, char **argv);
void ShowStreams (int argc, char **argv);
void Warning (const char *format, ...);

#endif
