/* show.c - part of crash
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/****************************************************************
*	vAu						*
****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <a_out.h>
#include <sys/xstart.h>
#include <sys/xunistd.h>
#include "crash.h"

/****************************************************************
*	I							*
****************************************************************/

void ShowQuit (int argc, char **argv)
{
    /* vZXI */
    exit (EXIT_SUCCESS);
}

/****************************************************************
*	R}h\					*
****************************************************************/

void ShowHelp (int argc, char **argv)
{
    printf ("fd [n]"	"\t\tt@Cnh\n"
	    "str [n]"	"\t\tt@CXg[\n"
	    "pos"	"\t\tA{[gʒu\n"
	    "proc"	"\t\tvZX}bv\n"
	    "stack"	"\t\tX^bN̏\n"
	    "help"	"\t\tR}h̕\\n"
	    "quit"	"\t\tI\n");
}

/****************************************************************
*	~ʒuo͂					*
****************************************************************/

void ShowPosition (int argc, char **argv)
{
    /* A{[gʒu\ */
    printf ("st@C          : %s\n", execFname);
    printf ("V{            : %d\n", binIndex);
    printf ("RAt@C          : %s\n", coreFname);
    printf ("RAC[W̃TCY    : %d\n", imageSize);
    printf ("vOJE^ (pc) : 0x%lx <%s>\n", core.pc, SearchByAddress (core.pc));
    printf ("X^bN|C^   (sp) : 0x%lx <%s>\n", core.sp, SearchByAddress (core.sp));
    printf ("Xe[^XWX^ (sr) : 0x%x\n", core.sr);
}

/****************************************************************
*	X^bNo͂					*
****************************************************************/

void ShowStack (int argc, char **argv)
{
    int i, columns;
    int address;
    int using, ssize;
    double percent;

    /* XP[߂ */
    using = core.hsta - core.sp;
    ssize = core.hsta - core.ssta;
    columns = using * 50 / ssize + 1;
    percent = (double) using / (double) ssize * 100.0;

    /* XP[KCh\ */
    printf ("0   10   20   30   40   50   60   70   80   90  100 (%%)\n");
    printf ("+----+----+----+----+----+----+----+----+----+----+\n");

    /* XP[\ */
    for (i = 0; i < columns; i++)
	putchar ('*');

    /* s */
    printf ("\n\n");

    /* T\ */
    printf ("X^bN̈̃TCY : %d\n", ssize);
    printf ("X^bN̈̐擪   : 0x%08lx\n", core.hsta);
    printf ("X^bN̈̍Ō   : 0x%08lx\n", core.ssta);
    printf ("X^bN|C^     : 0x%08lx\n", core.sp);
    printf ("X^bN̈̎gp : %d (%.2f%%)\n\n", using, percent);

    /* 16 i_ṽQ[W\ */
    printf ("AhX| +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +a +b +c +d +e +f\n");
    printf ("--------+------------------------------------------------");

    /* 16 i_v */
    address = core.sp - core.memcp - 0x30;
    for (i = 0; i < 0x70; i++) {
	if ((i & 15) == 0)
	    printf ("\n%08lx| ", address + core.memcp);
	printf ("%02x ", image[address++]);
    }

    /* s */
    putchar ('\n');
}

/****************************************************************
*	t@Cnh\					*
****************************************************************/

void ShowFileHandle (int argc, char **argv)
{
    int i, j, fd;
    struct _handles *hp;

    /* |C^Ƃ肾 */
    if ((hp = (struct _handles *) SearchByName ("__fddb")) == 0)
	return;

    /* 邩? */
    if (argc == 1) {

	/* \ */
	printf (" W  AvP[V\n");

	/* SẴt@Cnh\ */
	for (i = 0; i < OPEN_MAX; i++) {

	    /* Q[W\ */
	    if ((i & 15) == 0) {
		printf ("\n\n");
		for (j = i; (j < i + 16) && (j < OPEN_MAX); j++)
		    printf ("%02d ", j);
		putchar ('\n');
	    }

	    /* ԕ\ */
	    printf ("%s ", (hp[i].inuse == _FD_NOTUSED)
			? "~" : (hp[i].inuse == _FD_IMPORTED) ? "" : "");

	}

	/* s */
	putchar ('\n');

    }

    /* ꍇ... */
    else {

	/* ͈̓`FbN */
	if ((fd = atoi (argv[1])) < 0 || fd >= OPEN_MAX) {
	    fprintf (stderr, "sȃt@Cnh %d w肵܂\n", fd);
	    return;
	}

	/* CfbNXvZ */
	hp += fd;

	/* gp? */
	if (hp->inuse == _FD_NOTUSED) {
	    printf ("t@Cnh %d ͖gpł\n", fd);
	    return;
	}

	/* f[^\ */
	printf ("t@Cnh   : %d [%s]\n", fd, (hp->inuse == _FD_IMPORTED) ? "W" : "I[v");
	printf ("t@C̍폜\ : %s\n", hp->unlink ? "\񂠂" : "Ȃ");
	printf ("I[v[h     : 0x%x [%s]\n", hp->oflag, ConvertOpenMode (hp->oflag));
	printf ("ΏۃfoCX   : 0x%x [%s]\n", hp->iomd, ConvertDeviceMode (hp->iomd));
	printf ("ΏۃfoCX   : %sfoCX\n", hp->cdev ? "LN^" : "ubN");
	printf ("t@C̐΃pX : %s\n", hp->abspath);

    }
}

/****************************************************************
*	t@CXg[\					*
****************************************************************/

void ShowStreams (int argc, char **argv)
{
    int i, j, ind;
    struct _stdbuf *sp;

    /* |C^Ƃ肾 */
    if ((sp = (struct _stdbuf *) SearchByName ("__iob")) == 0)
	return;

    /* 邩? */
    if (argc == 1) {

	/* \ */
	printf (" W  AvP[V\n");

	/* SẴt@CXg[\ */
	for (i = 0; i < OPEN_MAX; i++) {

	    /* Q[W\ */
	    if ((i & 15) == 0) {
		printf ("\n\n");
		for (j = i; (j < i + 16) && (j < OPEN_MAX); j++)
		    printf ("%02d ", j);
		putchar ('\n');
	    }

	    /* ԕ\ */
	    printf ("%s ", (sp[i]._flag == 0)
			? "~" : (sp[i]._flag & _IOAPPLS) ? "" : "");

	}

	/* s */
	putchar ('\n');

    }

    /* ꍇ... */
    else {

	/* ͈̓`FbN */
	if ((ind = atoi (argv[1])) < 0 || ind >= OPEN_MAX) {
	    fprintf (stderr, "sȃXg[ %d w肵܂\n", ind);
	    return;
	}

	/* CfbNXvZ */
	sp += ind;

	/* gp? */
	if (sp->_flag == 0) {
	    printf ("t@CXg[ %d ͖gpł\n", ind);
	    return;
	}

	/* f[^\ */
	printf ("t@CXg[   : %d [%s]\n", ind, (sp->_flag & _IOAPPLS) ? "I[v" : "W");
	printf ("֘At@Cnh : %d\n", sp->_file);
	printf ("ăobt@TCY : %d\n", sp->_bufsiz);
	printf ("obt@JE^l   : %d\n", sp->_cnt);
	printf ("Xg[̌ݏ : %s\n", (sp->_flag & _IOR) ? "ǂݍݒ" : (sp->_flag & _IOW) ? "ݒ" : "");
	printf ("obt@̊Č   : %s\n", (sp->_flag & _IOFREE) ? "" : "[U[Ă邢͂Ȃ");
	printf ("obt@O[h : %s\n", (sp->_flag & _IONBF) ? "Ȃ" : (sp->_flag & _IOLBF) ? "s" : "S");
	printf ("Xg[̑     : 0x%x [%s]\n", sp->_flag, ConvertStreamMode (sp->_flag));

    }
}

/****************************************************************
*	vZX\					*
****************************************************************/

void ShowProcess (int argc, char **argv)
{
    /* f[^\ */
    printf ("vOJE^ (pc) : 0x%lx <%s>\n", core.pc, SearchByAddress (core.pc));
    printf ("X^bN|C^   (sp) : 0x%lx <%s>\n", core.sp, SearchByAddress (core.sp));
    printf ("Xe[^XWX^ (sr) : 0x%x\n", core.sr);
    printf ("t@C              : %s\n", core.fname);
    printf ("Ǘ|C^      : 0x%lx\n", core.memcp);
    printf ("vZXǗ|C^    : 0x%lx\n", core.procp);
    printf ("eLXgZNV      : 0x%lx ` 0x%lx\n", core.psta, core.dsta);
    printf ("f[^ZNV        : 0x%lx ` 0x%lx\n", core.dsta, core.bsta);
    printf ("BSS ZNV          : 0x%lx ` 0x%lx\n", core.bsta, core.csta);
    printf ("R}hC          : 0x%lx ` 0x%lx\n", core.csta, core.vsta);
    printf ("R}hC    : 0x%lx ` 0x%lx\n", core.vsta, core.esta);
    printf ("[JϐGA  : 0x%lx ` 0x%lx\n", core.esta, core.fsta);
    printf ("ϐz            : 0x%lx ` 0x%lx\n", core.fsta, core.ssta);
    printf ("X^bNZNV      : 0x%lx ` 0x%lx\n", core.ssta, core.hsta);
    printf ("q[vZNV        : 0x%lx ` 0x%lx\n", core.hsta, core.last);
    printf ("vZXI[            : 0x%x\n", (unsigned int) ((struct _mep *) &image[0])->block_end);
    printf ("ő              : 0x%lx\n", core.mmax);
}
