/* utils.c - part of crash
 * Copyright (C) 2000 Tachibana Eriko
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/****************************************************************
*	vAu						*
****************************************************************/

#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/dos.h>
#include "crash.h"

/****************************************************************
*	I[v[h͂				*
****************************************************************/

char *ConvertOpenMode (int mode)
{
    static char buffer[256];

    /* [h𕶎ɒ */
    sprintf (buffer, "RDONLY %s%s%s%s%s%s%s%s%s",
	     (mode & O_WRONLY) ? "WRONLY " : "",
	     (mode & O_RDWR) ? "RDWR " : "",
	     (mode & O_CREAT) ? "CREAT " : "",
	     (mode & O_EXCL) ? "EXCL " : "",
	     (mode & O_TRUNC) ? "TRUNC " : "",
	     (mode & O_TEXT) ? "TEXT " : "",
	     (mode & O_BINARY) ? "BINARY " : "",
	     (mode & O_APPEND) ? "APPEND " : "",
	     (mode & O_TXTEOF) ? "TXTEOF " : "");

    /* buffer Ԃ */
    return buffer;
}

/****************************************************************
*	foCX[h͂				*
****************************************************************/

char *ConvertDeviceMode (int mode)
{
    static char buffer[256];

    /* ɕϊ */
    sprintf (buffer, "%s%s%s%s%s%s%s",
	     (mode & _DEV_STDIN) ? "STDIN " : "",
	     (mode & _DEV_STDOUT) ? "STDOUT " : "",
	     (mode & _DEV_NUL) ? "NUL " : "",
	     (mode & _DEV_CLOCK) ? "CLOCK " : "",
	     (mode & _DEV_RAW) ? "RAW " : "",
	     (mode & _DEV_IOCTRL) ? "IOCTRL " : "",
	     (mode & _DEV_CDEV) ? "CHARACTER " : "BLOCK ");

    /* buffer Ԃ */
    return buffer;
}

/****************************************************************
*	Xg[[h͂				*
****************************************************************/

char *ConvertStreamMode (int mode)
{
    static char buffer[256];

    /* [h𕶎ɒ */
    sprintf (buffer, "%s%s%s%s%s%s%s%s%s",
	     (mode & _IOREAD) ? "READ " : "",
	     (mode & _IOWRITE) ? "WRITE " : "",
	     (mode & _IOAPPEND) ? "APPEND " : "",
	     (mode & _IOTRUNC) ? "TRUNC " : "",
	     (mode & _IOCREAT) ? "CREAT " : "",
	     (mode & _IOBIN) ? "BIN " : "",
	     (mode & _IOFREE) ? "FREE " : "",
	     (mode & _IOEOF) ? "EOF " : "",
	     (mode & _IOERR) ? "ERR " : "");

    /* buffer Ԃ */
    return buffer;
}
